package org.bitbucket.openisoj;

public class AdditionalAmount {
	private String _accountType;
	private String _amountType;
	private String _currencyCode;
	private String _sign;
	private String _amount;

	public AdditionalAmount() {
	}

	public AdditionalAmount(String value) throws Exception {
		if (value.length() != 20)
			throw new Exception("Value incorrect length for argument value");

		_accountType = value.substring(0, 2);
		_amountType = value.substring(2, 4);
		_currencyCode = value.substring(4, 7);
		_sign = value.substring(7, 8);
		_amount = value.substring(8);

	}

	public String getAccountType() {
		return _accountType;
	}

	public String getAmount() {
		return Utils.padLeft(_amount, 12, '0');
	}

	public String getAmountType() {
		return _amountType;
	}

	public String getCurrencyCode() {
		return _currencyCode;
	}

	public String getSign() {
		return _sign;
	}

	public long getValue() {
		if (_sign == null)
			return 0;
		if (_amount == null)
			return 0;

		long amt = Long.parseLong(_amount);
		if (_sign.equals("D"))
			return -amt;
		return amt;
	}

	public void setAccountType(String accountType) {
		_accountType = accountType;
	}

	public void setAmount(String amount) {
		_amount = Utils.padLeft(amount, 12, '0');
	}

	public void setAmountType(String amountType) {
		_amountType = amountType;
	}

	public void setCurrencyCode(String currencyCode) {
		_currencyCode = currencyCode;
	}

	public void setSign(String sign) {
		_sign = sign;
	}

	public void setValue(long value) {
		_sign = value < 0 ? "D" : "C";
		long amt = value < 0 ? -value : value;
		_amount = Long.toString(amt);
	}

	@Override
	public String toString() {
		return getAccountType() + getAmountType() + getCurrencyCode()
				+ getSign() + getAmount();
	}
}
