package org.bitbucket.openisoj;

import org.bitbucket.openisoj.fieldvalidator.FieldValidators;

public class Iso8583Rev93 extends Iso8583 implements IMessage {
	public Iso8583Rev93() {
		this(defaultTemplate);
	}

	public Iso8583Rev93(Template template) {
		super(template);
	}

	private static Template defaultTemplate;

	protected static Template getDefaultTemplate() {
		return (Template) defaultTemplate.clone();
	}

	static {
		defaultTemplate = new Template();
		try {
			defaultTemplate.put(Bit._002_PAN, FieldDescriptor.getAsciiVar(2, 19, FieldValidators.getN()));
			defaultTemplate.put(Bit._003_PROC_CODE, FieldDescriptor.getAsciiFixed(6, FieldValidators.getN()));
			defaultTemplate.put(Bit._004_TRAN_AMOUNT, FieldDescriptor.getAsciiFixed(12, FieldValidators.getN()));
			defaultTemplate.put(Bit._005_SETTLE_AMOUNT, FieldDescriptor.getAsciiFixed(12, FieldValidators.getN()));
			defaultTemplate.put(Bit._007_TRAN_DATE_TIME, FieldDescriptor.getAsciiFixed(10, FieldValidators.getN()));
			defaultTemplate.put(Bit._009_CONVERSION_RATE_SETTLEMENT,
					FieldDescriptor.getAsciiFixed(8, FieldValidators.getN()));
			defaultTemplate.put(Bit._011_SYS_TRACE_AUDIT_NUM, FieldDescriptor.getAsciiFixed(6, FieldValidators.getN()));
			defaultTemplate
					.put(Bit._012_LOCAL_TRAN_DATETIME, FieldDescriptor.getAsciiFixed(12, FieldValidators.getN()));
			defaultTemplate.put(Bit._014_EXPIRY_DATE, FieldDescriptor.getAsciiFixed(4, FieldValidators.getN()));
			defaultTemplate.put(Bit._016_CONVERSION_DATE, FieldDescriptor.getAsciiFixed(4, FieldValidators.getN()));
			defaultTemplate.put(Bit._022_POS_DATA_CODE, FieldDescriptor.getAsciiFixed(15, FieldValidators.getAns()));
			defaultTemplate.put(Bit._023_CARD_SEQ_NR, FieldDescriptor.getAsciiFixed(3, FieldValidators.getN()));
			defaultTemplate.put(Bit._024_FUNC_CODE, FieldDescriptor.getAsciiFixed(3, FieldValidators.getN()));
			defaultTemplate.put(Bit._027_APPROVAL_CODE_LEN, FieldDescriptor.getAsciiFixed(1, FieldValidators.getN()));
			defaultTemplate.put(Bit._028_RECON_DATE, FieldDescriptor.getAsciiFixed(6, FieldValidators.getN()));
			defaultTemplate.put(Bit._029_RECON_INDICATOR, FieldDescriptor.getAsciiFixed(3, FieldValidators.getN()));
			defaultTemplate.put(Bit._030_AMOUNTS_ORIGINAL, FieldDescriptor.getAsciiFixed(24, FieldValidators.getN()));
			defaultTemplate.put(Bit._032_ACQ_INST_ID_CODE, FieldDescriptor.getAsciiVar(2, 11, FieldValidators.getN()));
			defaultTemplate.put(Bit._035_TRACK_2_DATA, FieldDescriptor.getAsciiVar(2, 37, FieldValidators.getTrack2()));
			defaultTemplate.put(Bit._037_RET_REF_NR, FieldDescriptor.getAsciiFixed(12, FieldValidators.getAnp()));
			defaultTemplate.put(Bit._038_APPROVAL_CODE, FieldDescriptor.getAsciiFixed(6, FieldValidators.getAnp()));
			defaultTemplate.put(Bit._039_ACTION_CODE, FieldDescriptor.getAsciiFixed(3, FieldValidators.getN()));
			defaultTemplate.put(Bit._040_SERVICE_CODE, FieldDescriptor.getAsciiFixed(4, FieldValidators.getN()));
			defaultTemplate.put(Bit._041_TERMINAL_ID, FieldDescriptor.getAsciiFixed(8, FieldValidators.getAns()));
			defaultTemplate.put(Bit._042_CARD_ACCEPTOR_ID, FieldDescriptor.getAsciiFixed(15, FieldValidators.getAns()));
			defaultTemplate.put(Bit._044_ADDITIONAL_RESPONSE_DATA,
					FieldDescriptor.getAsciiVar(2, 99, FieldValidators.getAns()));
			defaultTemplate.put(Bit._045_TRACK_1_DATA, FieldDescriptor.getAsciiVar(2, 76, FieldValidators.getAns()));
			defaultTemplate.put(Bit._046_FEES_AMOUNTS, FieldDescriptor.getAsciiVar(3, 204, FieldValidators.getAns()));
			defaultTemplate.put(Bit._048_PRIVATE_ADDITIONAL_DATA,
					FieldDescriptor.getAsciiVar(4, 9999, FieldValidators.getAns()));
			defaultTemplate.put(Bit._049_TRAN_CURRENCY_CODE, FieldDescriptor.getAsciiFixed(3, FieldValidators.getN()));
			defaultTemplate.put(Bit._050_SETTLEMENT_CURRENCY_CODE,
					FieldDescriptor.getAsciiFixed(3, FieldValidators.getN()));
			defaultTemplate.put(Bit._052_PIN_DATA, FieldDescriptor.getAsciiFixed(16, FieldValidators.getHex()));
			defaultTemplate.put(Bit._053_SECURITY_INFO, FieldDescriptor.getAsciiVar(2, 96, FieldValidators.getHex()));
			defaultTemplate.put(Bit._054_ADDITIONAL_AMOUNTS,
					FieldDescriptor.getAsciiVar(2, 96, FieldValidators.getHex()));
			defaultTemplate.put(Bit._055_ICC_DATA, FieldDescriptor.getAsciiVar(3, 999, FieldValidators.getHex()));
			defaultTemplate
					.put(Bit._056_ORIG_DATA_ELEMENTS, FieldDescriptor.getAsciiVar(2, 35, FieldValidators.getN()));
			defaultTemplate
					.put(Bit._057_AUTH_LIFE_CYCLE_CODE, FieldDescriptor.getAsciiFixed(3, FieldValidators.getN()));
			defaultTemplate.put(Bit._058_AUTH_AGENT_INST_ID_CODE,
					FieldDescriptor.getAsciiVar(2, 11, FieldValidators.getN()));
			defaultTemplate.put(Bit._059_ECHO_DATA, FieldDescriptor.getAsciiVar(3, 200, FieldValidators.getAns()));
			defaultTemplate.put(Bit._062_HOTCARD_CAPACITY, FieldDescriptor.getAsciiVar(3, 5, FieldValidators.getN()));
			defaultTemplate.put(Bit._063_TERMAPP_PRIVATE_DATA,
					FieldDescriptor.getAsciiVar(3, 999, FieldValidators.getHex()));
			defaultTemplate.put(Bit._064_MAC, FieldDescriptor.getAsciiFixed(8, FieldValidators.getHex()));
			defaultTemplate.put(Bit._066_ORIGINAL_FEES_AMOUNTS,
					FieldDescriptor.getAsciiVar(3, 204, FieldValidators.getAns()));
			defaultTemplate.put(Bit._067_EXT_PAYMENT_DATA, FieldDescriptor.getAsciiFixed(2, FieldValidators.getN()));
			defaultTemplate.put(Bit._071_MSG_NR, FieldDescriptor.getAsciiFixed(8, FieldValidators.getN()));
			defaultTemplate.put(Bit._072_DATA_RECORD, FieldDescriptor.getAsciiVar(3, 999, FieldValidators.getAns()));
			defaultTemplate.put(Bit._074_NR_CREDITS, FieldDescriptor.getAsciiFixed(10, FieldValidators.getN()));
			defaultTemplate
					.put(Bit._075_NR_CREDITS_REVERSAL, FieldDescriptor.getAsciiFixed(10, FieldValidators.getN()));
			defaultTemplate.put(Bit._076_NR_DEBITS, FieldDescriptor.getAsciiFixed(10, FieldValidators.getN()));
			defaultTemplate.put(Bit._077_NR_DEBITS_REVERSAL, FieldDescriptor.getAsciiFixed(10, FieldValidators.getN()));
			defaultTemplate.put(Bit._081_NR_AUTHS, FieldDescriptor.getAsciiFixed(10, FieldValidators.getN()));
			defaultTemplate.put(Bit._086_AMOUNT_CREDITS, FieldDescriptor.getAsciiFixed(16, FieldValidators.getN()));
			defaultTemplate.put(Bit._087_AMOUNT_CREDITS_REVERSAL,
					FieldDescriptor.getAsciiFixed(16, FieldValidators.getN()));
			defaultTemplate.put(Bit._088_AMOUNT_DEBITS, FieldDescriptor.getAsciiFixed(16, FieldValidators.getN()));
			defaultTemplate.put(Bit._089_AMOUNT_DEBITS_REVERSAL,
					FieldDescriptor.getAsciiFixed(16, FieldValidators.getN()));
			defaultTemplate.put(Bit._090_NR_AUTHS_REVERSAL, FieldDescriptor.getAsciiFixed(10, FieldValidators.getN()));
			defaultTemplate.put(Bit._096_KEY_MANAGEMENT_DATA,
					FieldDescriptor.getAsciiVar(3, 999, FieldValidators.getAns()));
			defaultTemplate.put(Bit._097_AMOUNT_NET_RECON, FieldDescriptor.getAsciiFixed(17, FieldValidators.getAn()));
			defaultTemplate.put(Bit._098_PAYEE, FieldDescriptor.getAsciiFixed(25, FieldValidators.getAns()));
			defaultTemplate.put(Bit._100_RECEIVING_INST_ID_CODE,
					FieldDescriptor.getAsciiVar(2, 11, FieldValidators.getN()));
			defaultTemplate.put(Bit._101_FILE_NAME, FieldDescriptor.getAsciiVar(2, 99, FieldValidators.getAns()));
			defaultTemplate.put(Bit._102_ACCOUNT_ID_1, FieldDescriptor.getAsciiVar(2, 28, FieldValidators.getAns()));
			defaultTemplate.put(Bit._103_ACCOUNT_ID_2, FieldDescriptor.getAsciiVar(2, 28, FieldValidators.getAns()));
			defaultTemplate.put(Bit._104_TRAN_DESCRIPTION,
					FieldDescriptor.getAsciiVar(4, 9999, FieldValidators.getAns()));
			defaultTemplate.put(Bit._109_FEE_AMOUNTS_CREDITS,
					FieldDescriptor.getAsciiVar(2, 84, FieldValidators.getAns()));
			defaultTemplate.put(Bit._110_FEE_AMOUNTS_DEBITS,
					FieldDescriptor.getAsciiVar(2, 84, FieldValidators.getAns()));
			defaultTemplate.put(Bit._123_RECEIPT_DATA, FieldDescriptor.getAsciiVar(3, 999, FieldValidators.getAns()));
			defaultTemplate.put(Bit._124_DISPLAY_DATA, FieldDescriptor.getAsciiVar(3, 999, FieldValidators.getAns()));
			defaultTemplate.put(Bit._128_MAC, FieldDescriptor.getAsciiFixed(8, FieldValidators.getHex()));
		} catch (Exception e) {

		}
	}

	/** Human readable constants mapping to field numbers */
	public class Bit {

		/** Primary Account Number */
		public static final int _002_PAN = 2;

		/** Processing Code */
		public static final int _003_PROC_CODE = 3;

		/** Transaction Amount */
		public static final int _004_TRAN_AMOUNT = 4;

		/** Settlement Amount */
		public static final int _005_SETTLE_AMOUNT = 5;

		/** Transmission Date and Time */
		public static final int _007_TRAN_DATE_TIME = 7;

		/** Conversion Rate Settlement */
		public static final int _009_CONVERSION_RATE_SETTLEMENT = 9;

		/** Systems Trace Audit Number */
		public static final int _011_SYS_TRACE_AUDIT_NUM = 11;

		/** Field 12 - Time, Local Transaction */
		public static final int _012_LOCAL_TRAN_DATETIME = 12;

		/** Field 14 - Expiry Date */
		public static final int _014_EXPIRY_DATE = 14;

		/** Field 16 - Conversion Date */
		public static final int _016_CONVERSION_DATE = 16;

		/** Field 22 - POS Data Code */
		public static final int _022_POS_DATA_CODE = 22;

		/** Field 23 - Card Sequence Number */
		public static final int _023_CARD_SEQ_NR = 23;

		/** Field 24 - Function Code */
		public static final int _024_FUNC_CODE = 24;

		/** Field 25 - Message Reason Code */
		public static final int _025_MSG_REASON_CODE = 25;

		/** Field 27 - Approval Code Length */
		public static final int _027_APPROVAL_CODE_LEN = 27;

		/** Field 28 - Reconciliation Date */
		public static final int _028_RECON_DATE = 28;

		/** Field 29 - Reconciliation Indicator */
		public static final int _029_RECON_INDICATOR = 29;

		/** Field 30 - Original Amounts */
		public static final int _030_AMOUNTS_ORIGINAL = 30;

		/** Field 32 - Acquiring Institutino ID Code */
		public static final int _032_ACQ_INST_ID_CODE = 32;

		/** Field 35 - Track 2 Data */
		public static final int _035_TRACK_2_DATA = 35;

		/** Field 37 - Retrieval Reference Number */
		public static final int _037_RET_REF_NR = 37;

		/** Field 38 - Approval Code */
		public static final int _038_APPROVAL_CODE = 38;

		/** Field 39 - Action Code */
		public static final int _039_ACTION_CODE = 39;

		/** Field 40 - Service Code */
		public static final int _040_SERVICE_CODE = 40;

		/** Field 41 - Terminal ID */
		public static final int _041_TERMINAL_ID = 41;

		/** Field 42 - Card Acceptor ID */
		public static final int _042_CARD_ACCEPTOR_ID = 42;

		/** Field 44 - Additional Response Data */
		public static final int _044_ADDITIONAL_RESPONSE_DATA = 44;

		/** Field 45 - Track 1 Data */
		public static final int _045_TRACK_1_DATA = 45;

		/** Field 46 - Fees Amounts */
		public static final int _046_FEES_AMOUNTS = 46;

		/** Field 48 - Private Additional Data */
		public static final int _048_PRIVATE_ADDITIONAL_DATA = 48;

		/** Field 49 - Transaction Currency Code */
		public static final int _049_TRAN_CURRENCY_CODE = 49;

		/** Field 50 - Settlement Currency Code */
		public static final int _050_SETTLEMENT_CURRENCY_CODE = 50;

		/** Field 52 - PIN Data */
		public static final int _052_PIN_DATA = 52;

		/** Field 53 - Security Related Information */
		public static final int _053_SECURITY_INFO = 53;

		/** Field 54 - Additional Amounts */
		public static final int _054_ADDITIONAL_AMOUNTS = 54;

		/** Field 55 - ICC Data */
		public static final int _055_ICC_DATA = 55;

		/** Field 56 - Original Data Elements */
		public static final int _056_ORIG_DATA_ELEMENTS = 56;

		/** Field 57 - Auth Life Cycle Code */
		public static final int _057_AUTH_LIFE_CYCLE_CODE = 57;

		/** Field 58 - Authorizing Agent Institution ID Code */
		public static final int _058_AUTH_AGENT_INST_ID_CODE = 58;

		/** Field 59 - Echo Data */
		public static final int _059_ECHO_DATA = 59;

		/** Field 62 - Hotcard Capacity */
		public static final int _062_HOTCARD_CAPACITY = 62;

		/** Field 63 - TermApp.ISO Private Data */
		public static final int _063_TERMAPP_PRIVATE_DATA = 63;

		/** Field 64 - Message Authentication Code */
		public static final int _064_MAC = 64;

		/** Field 66 - Original Fees Amounts */
		public static final int _066_ORIGINAL_FEES_AMOUNTS = 66;

		/** Fiel 67 - Extended Payment Data */
		public static final int _067_EXT_PAYMENT_DATA = 67;

		/** Field 71 - Message Number */
		public static final int _071_MSG_NR = 71;

		/** Field 72 - Data Record */
		public static final int _072_DATA_RECORD = 72;

		/** Field 74 - Credits, Number */
		public static final int _074_NR_CREDITS = 74;

		/** Field 75 - Credits Reversal, Number */
		public static final int _075_NR_CREDITS_REVERSAL = 75;

		/** Field 76 - Debits, Number */
		public static final int _076_NR_DEBITS = 76;

		/** Field 77 - Debits Reversal, Number */
		public static final int _077_NR_DEBITS_REVERSAL = 77;

		/** Field 81 - Authorisations, Number */
		public static final int _081_NR_AUTHS = 81;

		/** Field 86 - Credits, Amount */
		public static final int _086_AMOUNT_CREDITS = 86;

		/** Field 87 - Credits Reversal, Amount */
		public static final int _087_AMOUNT_CREDITS_REVERSAL = 87;

		/** Field 88 - Debits, Amount */
		public static final int _088_AMOUNT_DEBITS = 88;

		/** Field 89 - Debits Reversal, Amount */
		public static final int _089_AMOUNT_DEBITS_REVERSAL = 89;

		/** Field 90 - Authorisations Reversal, Number */
		public static final int _090_NR_AUTHS_REVERSAL = 90;

		/** Field 96 - Key Management Data */
		public static final int _096_KEY_MANAGEMENT_DATA = 96;

		/** Field 97 - Net Reconciliation Amount */
		public static final int _097_AMOUNT_NET_RECON = 97;

		/** Field 98 - Payee */
		public static final int _098_PAYEE = 98;

		/** Field 100 - Receiving Institution ID Code */
		public static final int _100_RECEIVING_INST_ID_CODE = 100;

		/** Field 101 - File Name */
		public static final int _101_FILE_NAME = 101;

		/** Field 102 - Account ID 1 */
		public static final int _102_ACCOUNT_ID_1 = 102;

		/** Field 103 - Account ID 2 */
		public static final int _103_ACCOUNT_ID_2 = 103;

		/** Field 104 - Transaction Description */
		public static final int _104_TRAN_DESCRIPTION = 104;

		/** Field 109 - Fee Amounts, Credits */
		public static final int _109_FEE_AMOUNTS_CREDITS = 109;

		/** Field 110 - Fee Amounts, Debits */
		public static final int _110_FEE_AMOUNTS_DEBITS = 110;

		/** Fied 123 - Receipt Data */
		public static final int _123_RECEIPT_DATA = 123;

		/** Field 124 - Display Data */
		public static final int _124_DISPLAY_DATA = 124;

		/** Field 128 - Message Authentication Code */
		public static final int _128_MAC = 128;

	}

	/** Human readable constants mapping to message types */
	public static class MsgType {
		public static int getResponse(int msgType) {
			return msgType & 0xFFFE | 0x0010;
		}

		/** Invalid Message */
		public static final int _0000_INVALID_MSG = Iso8583.MsgType._0000_INVALID_MSG;

		/** Authorisation Request */
		public static final int _1100_AUTH_REQ = 0x1100;

		/** Authorisation Request Response */
		public static final int _1110_AUTH_REQ_RSP = 0x1110;

		/** Authorisation Advice */
		public static final int _1120_AUTH_ADV = 0x1120;

		/** Authorisation Advice Response */
		public static final int _1130_AUTH_ADV_RSP = 0x1130;

		/** Transaction Request */
		public static final int _1200_TRAN_REQ = 0x1200;

		/** Transaction Request Response */
		public static final int _1210_TRAN_REQ_RSP = 0x1210;

		/** Transaction Advice */
		public static final int _1220_TRAN_ADV = 0x1220;

		/** Transaction Advice Response */
		public static final int _1230_TRAN_ADV_RSP = 0x1230;

		/** File Action Request */
		public static final int _1304_FILE_ACTION_REQ = 0x1304;

		/** File Action Request Response */
		public static final int _1314_FILE_ACTION_REQ_RSP = 0x1314;

		/** Reversal Advice */
		public static final int _1420_TRAN_REV_ADV = 0x1420;

		/** Reversal Advice Response */
		public static final int _1430_TRAN_REV_ADV_RSP = 0x1430;

		/** Reconciliation Request */
		public static final int _1500_RECON_REQ = 0x1500;

		/** Reconciliation Request Response */
		public static final int _1510_RECON_REQ_RSP = 0x1510;

		/** Reconciliation Advice */
		public static final int _1520_RECON_ADV = 0x1520;

		/** Reconciliation Advice Response */
		public static final int _1530_RECON_ADV_RSP = 0x1530;

		/** Administration Request */
		public static final int _1604_ADMIN_REQ = 0x1604;

		/** Administration Request Response */
		public static final int _1614_ADMIN_REQ_RSP = 0x1614;

		/** Administration Advice */
		public static final int _1624_ADMIN_ADV = 0x1624;

		/** Administration Advice Response */
		public static final int _1634_ADMIN_ADV_RSP = 0x1634;

		/** Network Management Request */
		public static final int _1804_NWRK_MNG_REQ = 0x1804;

		/** Network Management Request Response */
		public static final int _1814_NWRK_MNG_REQ_RSP = 0x1814;
	}

	public class FuncCode {
		public static final String _100_ORIGINAL_AUTH = "100";
		public static final String _200_ADVICE_REQUIRED = "200";
		public static final String _201_RESULT_OUTSTANDING = "201";
		public static final String _301_ADD_RECORD = "301";
		public static final String _303_DELETE_RECORD = "303";
		public static final String _304_REPLACE_RECORD = "304";
		public static final String _305_ENQUIRY = "305";
		public static final String _306_REPLACE_FILE = "306";
		public static final String _380_DATA_MORE_TO_COME = "380";
		public static final String _381_DATA_NO_MORE_TO_COME = "381";
		public static final String _382_NO_DATA = "382";
		public static final String _383_FILE_TRANSFER_COMPLETE = "383";
		public static final String _384_FILE_TRANSFER_ABORTED = "384";
		public static final String _400_FULL_REVERSAL_REQUIRED = "400";
		public static final String _401_PARTIAL_REVERSAL_REQUIRED = "401";
		public static final String _690_ADMINISTRATIVE_NOTIFICATION = "690";
		public static final String _691_ADMINISTRATIVE_REQUEST = "691";
		public static final String _805_SPECIAL_INSTRUCTION = "805";
		public static final String _811_KEY_EXCHANGE = "811";

	}
}
