package org.bitbucket.openisoj;

import org.bitbucket.openisoj.formatter.Formatters;

public class Iso8583TermApp extends Iso8583Rev93 implements IMessage {

	private static Template template;

	static {
		template = getDefaultTemplate();
	}

	private boolean ascii;

	public Iso8583TermApp() {
		this(false);
	}

	public Iso8583TermApp(boolean ascii) {
		super();
		this.ascii = ascii;
		if (ascii)
			template.setBitmapFormatter(Formatters.getAscii());
		else
			template.setBitmapFormatter(Formatters.getBinary());
	}

	public Iso8583TermApp(byte[] data) throws Exception {
		super();
		unpack(data, 0);
	}

	@Override
	public byte[] toMsg() throws Exception {
		byte[] superMsg = super.toMsg();
		byte[] msg = new byte[superMsg.length + 1];

		if (ascii)
			msg[0] = 'A';
		else
			msg[0] = 'B';

		System.arraycopy(superMsg, 0, msg, 1, superMsg.length);

		return msg;
	}

	@Override
	public int unpack(byte[] msg, int startingOffset) throws Exception {
		ascii = msg[0] == 'A';
		if (ascii)
			template.setBitmapFormatter(Formatters.getAscii());
		else
			template.setBitmapFormatter(Formatters.getBinary());

		_bitmap = new Bitmap(template.getBitmapFormatter());

		return super.unpack(msg, startingOffset + 1);
	}
}
