package org.bitbucket.openisoj;

public class Utils {
	public static String maskPan(String pan) {
		if (pan == null)
			return null;

		final int frontLength = 6;
		final int endLength = 4;
		final int unmaskedLength = frontLength + endLength;

		int totalLength = pan.length();

		if (totalLength <= unmaskedLength)
			return pan;

		StringBuilder sb = new StringBuilder(totalLength);
		sb.append(pan.substring(0, frontLength));
		sb.append(Utils.padLeft("", totalLength - unmaskedLength, 'x'));
		sb.append(pan.substring((totalLength - endLength), totalLength));
		return sb.toString();
	}

	public static String padLeft(String data, int length, char padChar) {

		int remaining = length - data.length();

		String newData = data;
		for (int i = 0; i < remaining; i++)
			newData = padChar + newData;
		return newData;
	}

	public static String padRight(String data, int length, char padChar) {

		int remaining = length - data.length();

		String newData = data;

		for (int i = 0; i < remaining; i++)
			newData = newData + padChar;

		return newData;
	}
}
